
// This demo was originally written by the folks at www.dev-gallery.com.
// Ported to Yindo by Jim Mathies 
// Ported to Io by Steve Dekorte
// http //www.dev-gallery.com/programming/opengl/env_mapping/env_map1.htm


EnvironmentDemo := Object clone do(
  appendProto(OpenGL)
  angle := 0
  tex0 := 0
  tex1 := .33
  tex2 := .66
  tex3 := 1
  textureId := 1
)

EnvironmentDemo init := method(
  glEnable(GL_DEPTH_TEST)
  glEnable(GL_TEXTURE_2D)
  glClearColor(0, 0, 0, 1)
  self tex := Image clone open(Path with(launchPath, "texture.jpg"))
  self tex bindTexture
)

EnvironmentDemo display := method(
    glClear(GL_COLOR_BUFFER_BIT)
    glClear(GL_DEPTH_BUFFER_BIT)
    self tex bindTexture

    glPushMatrix 
    glRotated(self angle, 0.0, 0.0, 1.0)

    glBegin(GL_QUADS)
    glTexCoord2f(0.0, self tex1) ; glVertex3d(-20.0,-10.0,-20.0)
    glTexCoord2f(1.0, self tex1) ; glVertex3d(20.0,-10.0,-20.0) 
    glTexCoord2f(1.0, self tex2) ; glVertex3d(20.0, 10.0,-20.0) 
    glTexCoord2f(0.0, self tex2) ; glVertex3d(-20.0, 10.0,-20.0) 
    glEnd 

    glBegin(GL_QUADS)
    glTexCoord2f(0.0, self tex2) ; glVertex3d(-20.0, 10.0,-20.0)
    glTexCoord2f(1.0, self tex2) ; glVertex3d(20.0, 10.0,-20.0) 
    glTexCoord2f(1.0, self tex3) ; glVertex3d(20.0, 10.0, 20.0) 
    glTexCoord2f(0.0, self tex3) ; glVertex3d(-20.0, 10.0, 20.0) 
    glEnd 
		
    glBegin(GL_QUADS)
    glTexCoord2f(0.0,self tex1) ; glVertex3d(-20.0, -10.0,-20.0)
    glTexCoord2f(1.0,self tex1) ; glVertex3d(20.0, -10.0,-20.0)
    glTexCoord2f(1.0,self tex0) ; glVertex3d(20.0, -10.0, 20.0)
    glTexCoord2f(0.0,self tex0) ; glVertex3d(-20.0, -10.0, 20.0)
    glEnd 

    glPopMatrix 

    glPushMatrix 
    glEnable(GL_TEXTURE_GEN_S)
    glEnable(GL_TEXTURE_GEN_T)
    glRotated(self angle,1.0,1.0,1.0)
    glEnable(GL_CULL_FACE)
    glutSolidTorus(2.0,5.0,20,20)
    glDisable(GL_TEXTURE_GEN_S)
    glDisable(GL_TEXTURE_GEN_T)
    glDisable(GL_CULL_FACE)
    glPopMatrix 

    glFlush 
    glutSwapBuffers 
)

EnvironmentDemo reshape := method(width, height,
  glViewport(0, 0, width, height)
  glMatrixMode(GL_PROJECTION)
  glLoadIdentity 
  gluPerspective(60, width/height, 1, 1000)
  glMatrixMode(GL_MODELVIEW)
  glLoadIdentity 
  gluLookAt(0.0,0.0,25.0,0.0,0.0,0.0,0.0,1.0,0.0)
  glutPostRedisplay 
)

EnvironmentDemo timer := method(value,
  display 
  angle = angle + 1
  tex0 = tex0 + .01
  tex1 = tex1 + .01
  tex2 = tex2 + .01
  tex3 = tex3 + .01
  glutTimerFunc(1, 1)
)

EnvironmentDemo main := method(
    glutInit
    glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE)
    glutInitWindowSize(100, 100)
    //glutInitWindowPosition(100, 100)
    glutCreateWindow("Environment Demo")
    self init

    glutEventTarget(EnvironmentDemo)
    glutDisplayFunc
    glutReshapeFunc
    glutTimerFunc(1, 1)
    glutMainLoop 
)

EnvironmentDemo main 

