// A program to test OpenGL events
// Steve Dekorte, 2002

Screen := Object clone
Screen appendProto(OpenGL)

Screen do(
    width := 100
    height := 100
    needsDraw := 1

    reshape := method(w, h, 
	writeln("reshape ", w, " ", h)
	if (w != width or h != height, needsDraw = 1)
	width = w
	height = h
	glViewport(0,0,w,h)
	glMatrixMode(GL_PROJECTION)
	glLoadIdentity
	gluOrtho2D(0, w, 0, h)
	glMatrixMode(GL_MODELVIEW)
	glLoadIdentity
	glClearColor(1, 1, 1, 1)
	display
    )

    display := method(
	glLoadIdentity
	draw
	glFlush
    )

    draw := method(
	if (needsDraw == Nil, return)
	needsDraw = Nil
	glClear(GL_COLOR_BUFFER_BIT)
	
	writeln("draw")
	max := 100
	dx := 4 / width
	dy := 4 / height

	dx := 2 / width
	dy := 2 / height

  	//glBegin(GL_POINTS)
	for(x, 0, width,
  	glBegin(GL_POINTS)
	    for(y, 0, height,
		//r := mandlebrot(-2, -2, dx, dy, x, y, max)
		r := mandlebrot(-2, 0, dx, dy, x, y, max)
		glColor3d(r, r, r, 1)
		glVertex2d(x, y)

	    )
   	glEnd
	glFlush
	)
   	//glEnd	
   )

    timer := method(v,
	timerCount = timerCount + 1
	glutTimerFunc(1000, 0)
	//display
    )

    run := method(
	glutInitDisplayMode(GLUT_SINGLE | GLUT_RGBA)
	glutInitWindowSize(width, height)
	glutInit
	glutCreateWindow("Mandelbrot")
	glutEventTarget(Screen)
	glutDisplayFunc
	glutReshapeFunc
	glClear(GL_COLOR_BUFFER_BIT)
	glutMainLoop
    )
)

mandlebrot2 := method(xi, yi, max,
    count := max;
    x := 0;
    y := 0;

    while (count > 0,
	x2 := x * x
	y2 := y * y

	if (4 < x2 + y2, break)

	nx := x2 - y2 + xi
	y = 2 * x * y + yi
	x = nx
	count = count - 1
    )

    return max - count
)

Screen run

