// A program to test OpenGL events
// Steve Dekorte, 2002

Screen := Object clone
Screen appendProto(OpenGL)
Screen style := 0
Screen timersize := 0

Screen reshape := method(w, h, 
  self width := w
  self height := h
  glViewport(0,0,w,h)
  glMatrixMode(GL_PROJECTION)
  glLoadIdentity
  gluOrtho2D(0, w, 0, h)
  glMatrixMode(GL_MODELVIEW)
  glLoadIdentity
  glClearColor(0,0,0, 1)
  display
)


Screen display := method(
  glClear(GL_COLOR_BUFFER_BIT)
  glLoadIdentity
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
  glColor4d(1, 1, 1, .7)
  self perform("draw" .. style)
  glFlush
  glutSwapBuffers
)

Screen jitter2 := List clone append(
     Point clone set(.25, .75),
     Point clone set(.75, .25)
)

Screen jitter4 := List clone append(
     Point clone set(.375, .25),
     Point clone set(.125, .75),
     Point clone set(.875, .25),
     Point clone set(.625, .75)
)

Screen jitter := Screen jitter4


Screen show := method(s,
  glScaled(.2,.2, 1)
  glutStrokeString(GLUT_STROKE_ROMAN, s)
)

Screen draw0 := method(
  glDisable(GL_POLYGON_SMOOTH)
  self drawPolygon
  show("no smoothing")
)

Screen draw1 := method(
  glEnable(GL_POLYGON_SMOOTH)
  glDisable(GL_DEPTH_TEST)
  //glBlendFunc(GL_SRC_ALPHA_SATURATE, GL_ONE)
  self drawPolygon
  glDisable(GL_POLYGON_SMOOTH)
  show("GL_POLYGON_SMOOTH")
)

Screen draw2 := method(
  glDisable(GL_POLYGON_SMOOTH)
  glClear(GL_ACCUM_BUFFER_BIT)
  jitter foreach(j, 
    glClear(GL_COLOR_BUFFER_BIT)
    glPushMatrix 
    glTranslated(j x, j y, 0)
    self drawPolygon
    glPopMatrix
    glAccum(GL_ACCUM, 1.0/jitter size)
  )
  glAccum(GL_RETURN, 1.0)
  glFlush
  show("jitter + accumulation")
)

Screen draw3 := method(
  glColor4d(1, 1, 1, .5/(jitter size*.8))
  glDisable(GL_POLYGON_SMOOTH)
  jitter foreach(j, 
    glPushMatrix 
    glTranslated(j x, j y, 0)
    self drawPolygon
    glPopMatrix
  )
  glColor4d(1, 1, 1, .5)
  show("jitter with alpha blending")
)

Screen draw4 := method(
  glEnable(GL_POLYGON_SMOOTH)
  self drawPolygon
  show("GL_POLYGON_SMOOTH")
)

Screen drawPolygon := method(
  glPushMatrix
  glTranslated(width/2, height/2, 0)
  glRotated(-timersize, 0, 0, 1)
  gluPartialDisk(q, 100, 300, 32, 1, 0, 180) 
  glPopMatrix
)

Screen q := method(self q := gluNewQuadric)

Screen mouse := method(button, state, x, y,
  if (state == 1, style = style + 1)
  if (style > 3, style = 0)
  //write("mouse style = ", style, "\n")
  glutPostRedisplay
)

Screen timer := method(v,
  //write("timer\n")
  timersize =  timersize + .1
  if (timersize > 360, timersize := 0)
  glutTimerFunc(1000/60, 0)
  glutPostRedisplay
)

Screen run := method(
  glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGBA | GLUT_ACCUM | GLUT_ALPHA )
  glutInitWindowSize(800, 800)
  glutInit
  glutCreateWindow("Polygon Smoothing - press mouse button")
  glutEventTarget(Screen)
  glutDisplayFunc
  //glutKeyboardFunc
  //glutMotionFunc
  glutMouseFunc
  glutReshapeFunc
  //glutPassiveMotionFunc
  glutTimerFunc(100, 0)
  
  glEnable(GL_BLEND)
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
  glutMainLoop
)

Screen run


