
EditViewResizer := Button clone do(
    type := "EditViewResizer"
    size set(16,16)
    resizeWidth = 011
    resizeHeight = 011
    draw := method(
	glColor4d(0,0,1,.5)
	frame size drawLineLoopi
	writeln("EditViewResizer ", position x, "@", position y, " ", size x, "x", size y)
    )
)

Box copy := method(box,
    self origin copy(box origin)
    self size copy(box size)
)

EditView := Responder clone do(
    type := "EditView"
    
    setResizeWidth(101)
    setResizeHeight(101)

    init := method(
    	resend
	self resizer := EditViewResizer clone
	resizer position set(0, 0)
	resizer motionAction := "grow"
	resizer setActionTarget(self)
	addSubview(resizer)
	
    )
    contentView := Nil
    
    setContentView := method(view,
	contentView = view
	d := 8
	frame copy(contentView frame)
	frame size setWidth(frame size width + d)
	frame size setHeight(frame size height + d)
	
	resizer position copy(contentView frame size)
	resizer size set(d, d)
	
	contentView superview addSubview(self)
	contentView removeFromSuperview
	//addSubview(contentView)
	contentView frame origin set(0,0)
	
	self cvResizeWidth := contentView resizeWidth
	self cvResizeHeight := contentView resizeHeight

	contentView setResizeWidth(101)
	contentView setResizeHeight(101)
	self orderBack
    )
    
    grow := method(
	p := Mouse difference
	p setY(- p y)
	currentHeight := size height
	writeln("resizeBy(", p x, ", ", p y, ")")
	resizeBy(p x, p y)
	writeln("contentView ", contentView resizeWidth, " ", contentView resizeHeight)
	contentView resizeBy(p x, p y)
	position setY(position y - (size height - currentHeight))
	glutPostRedisplay
    )
        
    motion := method(
	moveWithMouseMotion
    )
    
    shiftLeftMouseDown := method(
	writeln("EditableView shiftLeftMouseDown")
	contentView frame origin copy(frame origin)
	superview addSubview(contentView)
	contentView setResizeWidth(cvResizeWidth)
	contentView setResizeHeight(cvResizeHeight)
	self removeFromSuperview
    )

    draw := method(
	contentView draw
	resend
	glColor4d(0,0,1,.5)
	frame size drawLineLoopi
    )
)

