
Mouse := Object clone do(
    position := Point clone
    lastPosition := Point clone
    tmpPoint := Point clone // assumes sequential access...
    button := 0
    state := 0
      
    doubleClick := 0
    lastClickTime := Date clone
    currentTime := Date clone

    mouse := method(b, s, mx, my,
	button = b
	state = s
	self motion(mx, my)
	doubleClick = 0
	if(s == 0,
	    if(currentTime now secondsSince(lastClickTime) < .2,  doubleClick = 1)
	)
	lastClickTime now
    )

    motion := method(mx, my,
	lastPosition copy(position)
	position set(mx, my, 0)
    )

    difference := method(
	//write("Mouse difference\n")
	//write("position:", position, "\n")
	//write("lastPosition:", lastPosition, "\n")
	tmpPoint copy(position) 
	tmpPoint -= lastPosition
	//write("diff:", tmpPoint, "\n")
	tmpPoint
    )
    
    setup := method(
	self mouseRoute := list()
	
	list("", "shift") foreach(mn,
	    dl := list()
	    mouseRoute append(dl)
	    
	    list("", "double") foreach(dn,
		dn = mn .. if (mn size != 0, dn asCapitalized, dn)
		bl := list()
		dl append(bl)
		
		list("left", "middle", "right") foreach(bn,
		    bn = dn .. if (dn size != 0, bn asCapitalized, bn)
		    sl := list()
		    bl append(sl)
		    
		    list("MouseDown", "MouseUp") foreach(sn,
			sn = bn .. if (bn size != 0, sn asCapitalized, sn)
			sl append(Message clone setName(sn))
		    )
		)
	    )
	)
    )
    
    setup
    removeSlot("setup") // so we can gc it
    
    stateMessage := method(
	mod := OpenGL glutGetModifiers
	//writeln("mod = ", mod)
	mouseRoute at(mod) at(doubleClick) at(button) at(state)
    )
)
