/*
 docCopyright("Steve Dekorte", 2002)
 docLicense("BSD revised")
 */

#include "IoState.h"
#include "IoObject.h"

// coros 

IoObject *IoState_currentCoroutine(IoState *self) 
{ 
	return self->currentCoroutine; 
}

size_t IoState_activeCoroCount(IoState *self)
{
	return Scheduler_coroCount(self->scheduler);
}

// current

void IoState_setCurrentCoroutine_(IoState *self, IoObject *coroutine) 
{ 
	self->currentCoroutine = coroutine; 
	self->currentIoStack = IoCoroutine_rawRetainedValues(coroutine);
}

void IoState_yield(IoState *self) 
{ 
	//printf("IoState_yielding currentCoroutine %p\n", (void *) self->currentCoroutine);
	IoCoroutine_rawYield(self->currentCoroutine); 
}

// control

void *IoState_prepareToPause(IoState *self) 
{ 
	IoCoroutine_rawPrepareToPause(self->currentCoroutine);
	return self->currentCoroutine;
}

void IoState_resume_(IoState *self, IoObject *coroutine) 
{ 
	IoCoroutine_rawResume(coroutine);
}

int IoState_yieldIfNeeded(IoState *self)
{
	 if (Scheduler_coroCount(self->scheduler) > 1) 
	 { 
		 IoCoroutine_rawYield(self->mainCoroutine); 
		 return 1; 
	 }
	 
	 return 0;
}
