/*#io
docCopyright("Steve Dekorte", 2002)
docLicense("BSD revised")
*/

#include "Base.h" 
#include "CStack.h"
#include <stdlib.h>
#include <string.h>
#include <stddef.h>

CStack *CStack_new(void)
{
	CStack *self = (CStack *)calloc(1, sizeof(CStack) + CSTACK_STACKSIZE);
	return self;
}

void CStack_free(CStack *self)
{
	free(self);
}

void CStack_context_(CStack *self, void *context) 
{ 
	self->context = context; 
}

void *CStack_context(CStack *self) 
{ 
	return self->context; 
}

// ---------------------------------- 

char CStack_markAndCall_with_(CStack *self, CStackCallback *func, void *c)
{
	// return 0 normally, or 1 if resumed 
	
	char r;
	
	if (!CSTACK_SETJMP(self->env))
	{ 
		(*func)(c); 
		r = 0; 
	}
	else
	{ 
		r = 1; 
	}
	
	return r;
}

void CStack_resume(CStack *self)
{
	CSTACK_LONGJMP(self->env, 1);
}


