/*   
 *   copyright: Steve Dekorte, 2002. All rights reserved.
 *   license: See _BSDLicense.txt.
 *  Notes: first element of items is always 0x0
 */
 
#define STACK_C
#include "Stack.h" 
#undef STACK_C

Stack *Stack_new(void) { return List_new(); }
void Stack_free(Stack *self) { List_free(self); }
Stack *Stack_clone(Stack *self) { return List_clone(self); }
void Stack_copy_(Stack *self, Stack *other) { List_copy_(self, other); }

/* --- stack -------------------------------------------------- */
size_t Stack_memorySize(Stack *self) { return List_memorySize(self); }
void Stack_compact(Stack *self) { List_compact(self); }

void Stack_clear(Stack *self) { List_clear(self); }
size_t Stack_totalSize(Stack *self) { return List_count(self); }

/* --- sizing ------------------------------------------------ */

void Stack_do_on_(Stack *self, StackDoOnCallback *callback, void *target)
{
  List_target_do_(self, target, callback);
}

Stack *Stack_newCopyWithoutMarks(Stack *self)
{
  List *list = List_clone(self);
  List_remove_(list, 0x0);
  return list;
}

void Stack_popToMark_(Stack *self, ptrdiff_t mark)
{
  if (List_count(self) < mark)
  {
      printf("Stack error: unable to find mark %i in %p\n", mark, (void *)self);
      exit(1); 
  }
  List_setLength_(self, mark);
}

